VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} formletter2pdf_form 
   Caption         =   "formletter2pdf"
   ClientHeight    =   7965
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   7605
   OleObjectBlob   =   "formletter2pdf_form.frx":0000
   StartUpPosition =   2  'Bildschirmmitte
End
Attribute VB_Name = "formletter2pdf_form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' **********************************************************************************************
' formletter2pdf
'
' Copyright 2013 Christian Bartl (www.formletter2pdf.com)
'
' Licensed under the Apache License, Version 2.0 (the "License");
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
'
' http://www.apache.org/licenses/LICENSE-2.0
'
' Unless required by applicable law or agreed to in writing, software
' distributed under the License is distributed on an "AS IS" BASIS,
' WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
' See the License for the specific language governing permissions and
' limitations under the License.
'
' This notice must appear in all copies of the script.
' **********************************************************************************************

Private Sub UserForm_Initialize()

    ' set desktop path as default value for FileLocation
    If System.OperatingSystem Like "*Mac*" Then
        Me.filelocation.Value = MacScript("return (path to desktop folder) as String")
    Else
        Me.filelocation.Value = CreateObject("WScript.Shell").SpecialFolders("Desktop")
    End If
    
    ' set other file type selection values
    Me.filetype_other_select.AddItem ("Word 97-2003 Document (.doc)")
    Me.filetype_other_select.AddItem ("Single File Web Page (.mht)")
    Me.filetype_other_select.AddItem ("Web Page (.htm)")
    Me.filetype_other_select.AddItem ("Web Page, Filtered (.htm)")
    Me.filetype_other_select.AddItem ("Rich Text Format (.rte)")
    Me.filetype_other_select.AddItem ("Plain Text (.txt)")

End Sub


Private Sub filetype_other_select_Change()
    Me.filetype_docx.Value = 0
    Me.filetype_docx.Value = 0
    Me.filetype_other.Value = 1
End Sub


Private Sub FileLocation_choose_Click()

    If System.OperatingSystem Like "*Mac*" Then

            'define Variables
            Dim MacScriptPath As String
            
            ' create browse for folder dialog
            On Error Resume Next
            MacScriptPath = MacScript("(choose folder with prompt ""Choose the location where the folder with the generated files should be stored.""" & _
    "default location alias """ & Me.filelocation.Value & """) as string")
            On Error GoTo 0
            
            ' save choosen path to FileLocation
            If MacScriptPath <> "" Then
                Me.filelocation.Value = MacScriptPath
            End If
        
    Else
    
        ' define variables
        Dim ShellApplication As Object
        Dim BrowseFileLocation As Object
    
        ' create browse for folder dialog
        Set ShellApplication = CreateObject("Shell.Application")
        Set BrowseFileLocation = ShellApplication.BrowseForFolder(0, "Choose the location where the folder with the generated files should be stored.", 0, 16)
       
        ' save choosen path to FileLocation
        If BrowseFileLocation Is Nothing Then
        ElseIf BrowseFileLocation = "Desktop" Then
            Me.filelocation.Value = CreateObject("WScript.Shell").SpecialFolders("Desktop")
        Else
            Me.filelocation.Value = BrowseFileLocation.items().Item().Path
        End If
    
    End If
    
End Sub


Private Sub cancel_Click()

    ' quit macro
    Unload Me
    
End Sub


Private Sub create_Click()
    
    '
    ' define variables
    '
    Dim Filetype As String
    Dim FileExtension As String
    Dim Location As String
    Dim Folder As String
    Dim Filename As String
    Dim Path As String
    Dim Tstamp As String
    Dim Counter As Integer
    Dim EmptyCounter As Integer
    Dim isDir As Integer
    Dim File As String
    Dim Targetfile As String


    '
    ' get values from form
    '
    
        ' get filetype
    Filetype = "pdf"
    If Me.filetype_docx.Value = True Then Filetype = "docx"
    
    If Me.filetype_other.Value = True Then
        If Me.filetype_other_select.Value = "" Then
            MsgBox "No other file type defined. Please choose a file type from the selectbox.", vbOKOnly + vbCritical
            Exit Sub
        Else
            Filetype = Me.filetype_other_select.Value
        End If
    End If
    
        ' get FileLocation
    If Me.filelocation.Value = "" Then
        MsgBox "Please provide a storage location where the generated files can be saved to.", vbOKOnly + vbCritical
        Exit Sub
    Else
        Location = Me.filelocation.Value
    End If
    
        ' get foldername
    If Me.foldername.Value = "" Then
        MsgBox "Please provide a folder name.", vbOKOnly + vbCritical
        Exit Sub
    Else
        Folder = Me.foldername.Value
    End If
    
        ' get Filename
    If Me.filenamepattern.Value = "" Then
        MsgBox "Please provide a file name pattern.", vbOKOnly + vbCritical
        Exit Sub
    Else
        Filename = Me.filenamepattern.Value
    End If
        
        
    '
    ' determine path and create target folder
    '
    
        ' determine storage location path
    Tstamp = Format(Now, "dd.mm.yyyy-hh.mm.ss")
    Folder = Replace(Folder, "{%timestamp%}", Tstamp)
    
    If System.OperatingSystem Like "*Mac*" Then
        Path = Location & Folder & ":"
    Else
        Path = Location & "\" & Folder & "\"
    End If
    
        ' check if target folder already exists, abort if, create if not
    If System.OperatingSystem Like "*Mac*" Then
        If MacScript("tell application " & Chr(34) & "Finder" & Chr(34) & Chr(13) & "exists folder " & Chr(34) & Path & Chr(34) & Chr(13) & "end tell" & Chr(13)) = True Then
            isDir = 1
        Else
            isDir = 0
        End If
        
        On Error GoTo ErrorHandling
    Else
        isDir = Len(Dir(Path, vbDirectory))
        On Error GoTo ErrorHandling
    End If
    
    If isDir = 0 Then
        If System.OperatingSystem Like "*Mac*" Then
           MacScript ("tell application " & Chr(34) & "Finder" & Chr(34) & Chr(13) & "make new folder at " & Chr(34) & Location & Chr(34) & " with properties {name: " & Chr(34) & Folder & Chr(34) & "}" & Chr(13) & "end tell" & Chr(13))
        Else
            Dim fso, f
            Set fso = CreateObject("Scripting.FileSystemObject")
            fso.CreateFolder (Path)
            'MkDir Path
        End If
        
        On Error GoTo ErrorHandling
    Else
        MsgBox "A folder with the given name already exists at the storage location. Please provide another folder name or change the storage location.", vbOKOnly + vbCritical
        Exit Sub
    End If
    
    

    '
    ' show info dialog and hide word application for better performance
    '
    
    If System.OperatingSystem Like "*Mac*" Then
        If MsgBox("The process of saving the single files can take a couple of minutes, depending on the amount of files. The formletter2pdf window will be hidden during this time. Want to continue?", vbOKCancel + vbInformation) = vbCancel Then Exit Sub
         formletter2pdf_form.Hide
    Else
        If MsgBox("The process of saving the single files can take a couple of minutes, depending on the amount of files. Microsoft Word will be hidden during this time to increase the performance. Want to continue?", vbOKCancel + vbInformation) = vbCancel Then Exit Sub
    End If
    Application.Visible = False
    Application.ScreenUpdating = False

    
    '
    ' save form letter to single files
    '
    
    Counter = 1
    
    With ActiveDocument.MailMerge
        
        ' determine amount of files
        .DataSource.ActiveRecord = wdLastRecord
        RecordCount = .DataSource.ActiveRecord
        .DataSource.ActiveRecord = 1
        
        Do
            ' create single files
            .Destination = wdSendToNewDocument
            .SuppressBlankLines = True

            With .DataSource
                .FirstRecord = .ActiveRecord
                .LastRecord = .ActiveRecord
            End With
            
            ' determine filename
            With .DataSource
                
                    ' replace datasource field markers
                EmptyCounter = 0
                File = Filename
                For Each Column In .DataFields
                    File = Replace(File, "{" & Column.Name & "}", Column.Value)
                    If Column.Value = "" Then EmptyCounter = EmptyCounter + 1
                Next Column
                
                    ' skip actual record if all columns of the record are empty
                If EmptyCounter = .DataFields.Count Then
                    Counter = Counter - 1
                    GoTo NextLoop
                End If
                
                    ' replace generic counter marker
                File = Replace(File, "{%counter%}", Counter)
                
                    ' replace all characters which are not allowed in Filenames (Chr(34) = ")
                File = Replace(File, "\", "")
                File = Replace(File, "/", "")
                File = Replace(File, ":", "")
                File = Replace(File, "*", "")
                File = Replace(File, "?", "")
                File = Replace(File, Chr(34), "")
                File = Replace(File, "<", "")
                File = Replace(File, ">", "")
                File = Replace(File, "|", "")
                
            End With
            
            ' surpress any mailmerge error
            .Execute Pause:=False
       
            ' save the single document
            Targetfile = Path & File & "."
            
            If Filetype = "docx" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "docx", FileFormat:=wdFormatDocumentDefault
            ElseIf Filetype = "Word 97-2003 Document (.doc)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "doc", FileFormat:=wdFormatDocument97
            ElseIf Filetype = "Single File Web Page (.mht)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "mht", FileFormat:=wdFormatWebArchive
            ElseIf Filetype = "Web Page (.htm)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "htm", FileFormat:=wdFormatHTML
            ElseIf Filetype = "Web Page, Filtered (.htm)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "htm", FileFormat:=wdFormatFilteredHTML
            ElseIf Filetype = "Rich Text Format (.rte)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "rte", FileFormat:=wdFormatText
            ElseIf Filetype = "Plain Text (.txt)" Then
                ActiveDocument.SaveAs Filename:=Targetfile & "txt", FileFormat:=wdFormatEncodedText
            Else
                ActiveDocument.SaveAs Filename:=Targetfile & "pdf", FileFormat:=wdFormatPDF
            End If
            
            ' close the single document
            ActiveDocument.Close False
       
            ' get next record from datasource
NextLoop:
            If .DataSource.ActiveRecord < RecordCount Then
               .DataSource.ActiveRecord = .DataSource.ActiveRecord + 1
                Counter = Counter + 1
            Else
                Exit Do
            End If
        Loop
    End With
    
    
    '
    ' show result and error messages and unhide word application
    '
    
ErrorHandling:

    Application.Visible = True
    Application.ScreenUpdating = True

    If Err.Number = 75 Then
        MsgBox "You do not have proper file system rights on the given storage location. Please choose another storage location.", vbOKOnly + vbCritical
    ElseIf Err.Number = 76 Then
        MsgBox "The given location isn't a valid storage location. Please choose another storage location.", vbOKOnly + vbCritical
    ElseIf Err.Number = 4198 Then
        MsgBox "formletter2pdf has been aborted, because an invalid file name has been detected. Please check the values of the fields used in the file name pattern for invalid characters and run formletter2pdf again.", vbOKOnly + vbCritical
        Unload Me
    ElseIf Err.Number = 5852 Then
        MsgBox "formletter2pdf could not save single files, because this document isn't a form letter. Please start the mail merge function first and then run formletter2pdf again.", vbOKOnly + vbCritical
        Unload Me
    ElseIf Err.Number > 0 Then
        MsgBox "Unknown Error: " & Err.Number & " - Please try to run formletter2pdf again.", vbOKOnly + vbCritical
        Unload Me
    Else
        If Counter > 1 Then
            MsgBox Counter & " form letters exported successfully!", vbOKOnly + vbInformation
        Else
            MsgBox Counter & " form letter exported successfully!", vbOKOnly + vbInformation
        End If
        Unload Me
    End If
    
    
End Sub


